﻿define(["sitecore", "jquery"], function (Sitecore, JQuery) {
    var self = this;
    var Api = {
        ajax: function (url, type, settings, data, etag) {
            var access_token;
            if (localStorage) {
                access_token = localStorage.getItem("access_token");
            }

            var defaults = {
                type: type,
                url: url, 
                headers: { 'Authorization': "Bearer " + access_token }
            };

            if (data) {
                defaults.data = JSON.stringify(data);
                defaults.contentType = 'application/json; charset=utf-8';
            }

            if (etag) {
                defaults.headers['If-Match'] = etag;
            }

            var options = $.extend(true, {}, defaults, settings);
            return $.ajax(options);
        },
        get: function (url, settings) { return this.ajax(url, 'GET', settings); },
        head: function (url, settings) { return this.ajax(url, 'HEAD', settings); },
        put: function (url, data, etag, settings) { return this.ajax(url, 'PUT', settings, data, etag); },
        post: function (url, data, etag, settings) { return this.ajax(url, 'POST', settings, data, etag); },
        del: function (url, settings) { return this.ajax(url, 'DELETE', settings); },
        patch: function (url, data, etag, settings) { return this.ajax(url, 'PATCH', settings, data, etag); }
    }
    return Api;
});